package matsubara.carcontroller;

/**
 * <p>^Cg: Car Controller</p>
 * <p>: N}̐EgX~bVȂǂ𐧌䂷</p>
 * <p>쌠: Copyright (c) 2002 m.matsubara </p>
 * @author m.matsubara
 * @version 1.0.2
 */

public abstract class CarController {
  String m_sShiftPosition;
  boolean m_bParkingBrake;

  double m_rOdoMeter = 0;     //  Ih[^[iZbgsj
  double m_rTripMeter = 0;    //  gbv[^[iZbgj
  double m_rAcceleration = 0; //  x
  double m_rFuel = 50;        //  Rcʁi̒lȂ̂ŔhNXŃI[o[Chقǂj
  double m_rTotalUseFuel = 0;      //  Rgp
  double m_rFuelEfficiency = 0;
  protected long m_nIgnitionTime;       //  COjbVs

  public CarController() {
    m_sShiftPosition = "N";   //  m|WVȂ炽Ă̎ԂɂĂ邾낤iȂႢȂjBhNXŏ㏑B
    m_bParkingBrake = false;
  }

  /**
   * Vtg|WV
   * ShiftPosition ̒lƂĎۂɂǂ̂悤Ȓl邩̓TuNXɈˑ
   * "P","R","N","D","3","2","L"  "1","2","3","4","5","R","N" Ȃ
   * @return Vtg|WV
   */
  public String getShiftPosition() {
    return m_sShiftPosition;
  }
  /**
   * Vtg|WV̐ݒ
   * @param sShiftPosition Vtg|WV
   */
  public void setShiftPosition(String sShiftPosition) {
    m_sShiftPosition = sShiftPosition;
  }

  /**
   * p[LOu[L̏Ԃ擾
   * @return p[LOu[LgpĂ true
   */
  public boolean isParkingBrake() {
    return m_bParkingBrake;
  }
  /**
   * p[LOu[L̏Ԃݒ
   * @param bParkingBrake
   */
  public void setParkingBkare(boolean bParkingBrake) {
    m_bParkingBrake = bParkingBrake;
  }

  /**
   * Rcʂ擾
   * @return Rc(L)
   */
  public double getFuel() {
    return m_rFuel;
  }
  /**
   * Rcʂݒ
   * @param rFuel Rc(L)
   */
  public void setFuel(double rFuel) {
    m_rFuel = rFuel;
  }

  /**
   * Ԃ̏ԂV~[g
   * Ih[^[Agbv[^[ARʂŌvZ
   * @param rMilliSec oߕb
   * @param nAccel ANZ̓ݍݗ(%)
   * @param nBrake u[L̓ݍݗ(%)
   */
  final public void drive(double rMilliSec, int nAccel, int nBrake) {
    double rLastSpeed = getSpeed();
    //  hNXł̎Ăяo
    driveInternal(rMilliSec, nAccel, nBrake);

    //  Ih[^[ƃgbv[^[
    double rSpeed = Math.abs(getSpeed());
    m_rOdoMeter += rSpeed * rMilliSec / (1000 * 60 * 60);
    m_rTripMeter += rSpeed * rMilliSec / (1000 * 60 * 60);
    m_rAcceleration = (getSpeed() - rLastSpeed) * 1000 / 3600 / (rMilliSec / 1000); // m/s2

    //  RvZ
    double rUseFuel = getUseFuel(rMilliSec);
    if (rSpeed != 0) {
      if (rUseFuel != 0)
        m_rFuelEfficiency = (Math.abs(getSpeed()) / 3600 / 1000 * rMilliSec) / rUseFuel;
      else
        m_rFuelEfficiency = Double.POSITIVE_INFINITY;
      if (m_rFuelEfficiency > 99.9)
        m_rFuelEfficiency = java.lang.Double.POSITIVE_INFINITY;
    }
    else
      m_rFuelEfficiency = 0;

    m_rTotalUseFuel += rUseFuel;

    //  Rc
    m_rFuel -= rUseFuel;
    if (m_rFuel < 0)
      m_rFuel = 0;
  }

  /**
   * drive \bhĂяo
   * eTuNXŎۂɎԂ̓V~[g
   * @param rMilliSec oߕb
   * @param nAccel ANZ̓ݍݗ(%)
   * @param nBrake u[L̓ݍݗ(%)
   */
  protected abstract void driveInternal(double rMilliSec, int nAccel, int nBrake);

  /**
   * ԑ擾
   * @return ԑ(km/h)
   */
  public abstract double getSpeed();
  /**
   * GW]擾
   * @return GW](rpm)
   */
  public abstract double getEngineRpm();

  /**
   * O drive \bhŏꂽR(L)
   * TuNXŎׂ
   * RvZ̃T|[g͕svȂȂĂǂA\ȂTuNXŃI[o[Chׂ
   * @param rMilliSec
   * @return Rgp(L)
   */
  protected double getUseFuel(double rMilliSec) {
    return 0; //
  }

  /**
   * Ih[^[l擾
   * @return Ih[^[l(km)
   */
  public int getOdoMeter() {
    return (int)m_rOdoMeter;
  }

  /**
   * gbv[^[l擾
   * @return gbv[^[l(km)
   */
  public double getTripMeter() {
    return m_rTripMeter;
  }

  /**
   * gbv[^[Zbg
   */
  public void resetTripMeter() {
    m_rTripMeter = 0;
  }

  /**
   * ݂܂ł̗ݐσK\gp
   * @return ݂܂ł̗ݐσK\gp
   */
  public double getTotalUseFuel() {
    return m_rTotalUseFuel;
  }

  /**
   * ݂܂ł̗ݐσK\gpʂZbg
   */
  public void resetTotalUseFuel() {
    m_rTotalUseFuel = 0;
  }

  /**
   * Odrive\bhŌĂяoꂽƂ̉x(m/s2)擾
   * @return x(m/s2)1bԂɉx(m/s)
   */
  public double getAcceleration() {
    return m_rAcceleration;
  }

  /**
   * Odrive\bhŌĂяoꂽƂ̔R(km/L)擾
   * ̃\bh삷ɂ getUseFuel ƎĂȂ΂ȂȂ
   * @return R(km/L)
   */
  public double getFuelEfficiency() {
    return m_rFuelEfficiency;
  }

  //  GW̓_
  public void ignition() {
    m_nIgnitionTime = System.currentTimeMillis();
  }

  //  GW؂
  public void unIgnition() {
    m_nIgnitionTime = 0;
  }

  //  GW_΂Ă邩
  public boolean isIgnition() {
      return (m_nIgnitionTime != 0);
  }

  public long getIgnitionTime() {
    return m_nIgnitionTime;
  }

}
